'- BROWSER
'Use the Explorer object to create a very simple web browser.
'demonstrates the use of events.
'based on helper file for SHDOCVW.DLL

$typecheck on
$equalprec on
$include "genericCOM.inc"

declare sub clic
declare sub doresize

create f as form
onresize=doresize
create e as edit: text="http://www.angelfire.com/space/netcensus/hotbasic.html": width=300: end create
create b as button: caption="Go!": onclick=clic: end create
create wb as ACTIVEX 'web browser
 width=500: height=300
 CreateActiveX("Shell.Explorer.1")
 SetEvent(108, codeptr(onProgressChange)) 'onProgressChange
 SetEvent(102, codeptr(onStatusTextChange)) 'onStatusTextChange
 SetEvent(100, codeptr(onBeforeNavigate)) 'onBeforeNavigate
end create
end create
f.showmodal
end

' Choosing the event interface
'By default, a Shell.Explorer.1 responds to the DWebBrowserEvents events.
'When calling CreateActiveX, the object is connected to that set of events.
'But this object can also respond to DWebBrowserEvents2 (notice the 2 at the end), which is another (richer) set of events.
'In order to connect the object to DWebBrowserEvents2, use the following 2 lines:
    'wb.DisconnectEvents 'cancel previous event connection(s)
    'wb.ConnectEvents("{34A715A0-6587-11D0-924A-0020AFC7AC4D}") 'connect to IID_DWebBrowserEvents2
'Be careful that although some events have identical or similar names in both event sets, the syntax of the event subs may not be the same.
'The safe approach is always to generate template code with ComHelper and to copy/paste it in your program.

'DWebBrowserEvents2 is actually the default event interface of object Shell.Explorer.2 (again, notice the 2 at the end)
'If you create a Shell.Explorer.2 object, it is automatically connected to that event interface. You can switch to 
'the basic DWebBrowserEvents by doing the converse operation:
    'wb2.DisconnectEvents 'cancel previous event connection(s)
    'wb2.ConnectEvents("{EAB22AC2-30C1-11CF-A7EB-0000C05BAE0B}") 'connect to IID_DWebBrowserEvents

sub clic
wb.invoke("Navigate", e.text, void, void, void, void)
end sub

sub doresize
wb.left=b.left
wb.width=f.clientwidth-2*b.left
wb.height=f.clientheight-wb.top-b.left
end sub

'ACTIVEX Event handlers
'directly copied from templates generated by ComHelper

  ''  .onBeforeNavigate -- Fired when a new hyperlink is being navigated to.
declare sub onBeforeNavigate STD ( _
    vURL as variant, _ ' STRING [VT_BSTR]
    vFlags as variant, _ ' integer [VT_I4]
    vTargetFrameName as variant, _ ' STRING [VT_BSTR]
    vPostData as variant, _ ' VARIANT [VT_VARIANT]
    vHeaders as variant, _ ' STRING [VT_BSTR]
    vCancel as variant) ' integer [BYREF] LONG [VT_BOOL]
sub onBeforeNavigate
if instr(lcase$(vURL),"hotbasic") then
    if messagebox("You are about to access a page whose address contains HotBasic."+crlf+ _
      "Are you sure you want to proceed?", "Internet warning", 4)<>6 then
     setindirect(vCancel,1) 'puts 1 in the memory address pointed by vCancel. that cancels the link.
    else
        e.text=vURL
    end if
else
    e.text=vURL
end if
end sub

  ''  .onProgressChange -- Fired when download progress is updated.
declare sub onProgressChange STD  _
   (vProgress as variant, _ ' LONG [VT_I4]  
    vProgressMax as variant) ' LONG [VT_I4]  
sub onProgressChange
defint progmax=vProgressMax
if progmax then
    defint pc=int(100*vProgress/progmax)
    f.caption=str$(pc)+"% complete"
end if
end sub

  ''  .onStatusTextChange -- Statusbar text changed.
declare sub onStatusTextChange STD  _
   (vText as variant) ' STRING [VT_BSTR]  
sub onStatusTextChange
f.caption=vText
end sub

